#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int main() {
    int n, q, zaliha=0, zadnji, dostupnidani, ukp=0;
    do {
      printf("Unesi broj pronalazenja plazme: ");
      scanf("%d", &n);
    }while (1>n || n>(3*pow(10, 5)));
    do {
     printf("Unesi broj pitanja: ");
    scanf("%d", &q);
    }while (1>q || q>(3*pow(10, 5)));
    int d[n], p[n], k[q];
    do{
        printf("Unesi dan kada je plazma kupljena po %d. put: ", 1);
        scanf("%d", &d[0]);
        }while(1>d[0] || d[0]>pow(10, 18));
    do {
        printf("Unesi koliko je otac kupio pakovanja tog dana: ");
        scanf("%d", &p[0]);
        }while(1>p[0] || p[0]>pow(10,18));
    for (int i=1; i<n; i++){
        do{
        printf("Unesi dan kada je plazma kupljena po %d. put: ", i+1);
        scanf("%d", &d[i]);
        }while(1>d[i] || d[i]>pow(10,18) && d[i]>d[i-1]);
        do{
        printf("Unesi koliko je otac kupio pakovanja tog dana: ");
        scanf("%d", &p[i]);
        }while(1>p[i] || p[i]>pow(10,9));

    }
    do{
      printf("Da je tog dana bio zadnji dan kada je jela plazmu, koji bi to bio dan? ");
      scanf("%d", &k[0]);
    }while (1>k[0] || k[0]>pow(10,18));

    for (int j=1; j<q; j++){
        do {
        printf("Da je tog dana bio zadnji dan kada je jela plazmu, koji bi to bio dan? ");
        scanf("%d", &k[j]);
        }while(1<k[j] || k[j]>pow(10, 18) && k[j]>k[j-1]);
    }

    for (int j=0; j<q; j++){
        zadnji=k[j];
        for (int i=0; i<n; i++){
                if (zadnji>d[i]){
                    zaliha=zaliha+p[i];
                    if (i==n-1 || d[i+1]>zadnji){
                        dostupnidani = zadnji-d[i]+1;
                    }
                    else {
                    dostupnidani = d[i+1]-d[i];
                    }
                    if (dostupnidani>zaliha){
                        ukp = ukp+zaliha;
                        zaliha = 0;
                    }
                    else {
                        ukp = ukp+dostupnidani;
                        zaliha=zaliha-dostupnidani;
                    }
                }
            }
        }
        printf("Cerka je do %d. dana pojela %d pakovanja", zadnji, ukp);
        return 0;
    }